URL: https://github.com/freeipa/freeipa/pull/618
Author: tiran
 Title: #618: [WIP] Tox testing support for client wheel packages
Action: synchronized

To pull the PR as Git branch:
git remote add ghfreeipa https://github.com/freeipa/freeipa
git fetch ghfreeipa pull/618/head:pr618
git checkout pr618
From 5a5c840bc994a3e217e22f4ff01eee7f3fe300ab Mon Sep 17 00:00:00 2001
From: Christian Heimes <chei...@redhat.com>
Date: Thu, 17 Nov 2016 16:43:17 +0100
Subject: [PATCH] tox testing support for client wheel packages

Signed-off-by: Christian Heimes <chei...@redhat.com>
---
 .gitignore           |  2 ++
 .tox-install.sh      | 64 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 Makefile.am          |  2 ++
 configure.ac         |  1 +
 ipatests/conftest.py |  5 ++--
 tox.ini              | 38 +++++++++++++++++++++++++++++++
 6 files changed, 110 insertions(+), 2 deletions(-)
 create mode 100755 .tox-install.sh
 create mode 100644 tox.ini

diff --git a/.gitignore b/.gitignore
index 8941fd8..8b57dbc 100644
--- a/.gitignore
+++ b/.gitignore
@@ -61,6 +61,8 @@ freeipa2-dev-doc
 # Root directory
 /freeipa.spec
 /dist/
+/.tox/
+/.cache/
 /*/dist/
 /RELEASE
 /rpmbuild/
diff --git a/.tox-install.sh b/.tox-install.sh
new file mode 100755
index 0000000..9747d14
--- /dev/null
+++ b/.tox-install.sh
@@ -0,0 +1,64 @@
+#!/bin/bash
+set -ex
+
+ENVPYTHON="$1"
+ENVSITEPACKAGESDIR="$2"
+# 3...end are package requirements
+shift 2
+
+TOXINIDIR="$(cd "$(dirname "$0")" && pwd)"
+
+# sanity checks
+if [ ! -x "${ENVPYTHON}" ]; then
+    echo "${ENVPYTHON}: no such executable"
+    exit 1
+fi
+
+if [ ! -d "${ENVSITEPACKAGESDIR}" ]; then
+    echo "${ENVSITEPACKAGESDIR}: no such directory"
+    exit 2
+fi
+
+if [ ! -f "${TOXINIDIR}/tox.ini" ]; then
+    echo "${TOXINIDIR}: no such directory"
+    exit 3
+fi
+
+# https://pip.pypa.io/en/stable/user_guide/#environment-variables
+export PIP_CACHE_DIR="${TOXINIDIR}/.tox/cache"
+mkdir -p "${PIP_CACHE_DIR}"
+
+DISTBUNDLE="${TOXINIDIR}/dist/bundle"
+mkdir -p "${DISTBUNDLE}"
+
+# create configure
+pushd "${TOXINIDIR}"
+if [ ! -f "configure" ]; then
+    autoreconf -i -f
+fi
+# (re)create Makefile
+./configure --disable-server
+popd
+
+# copy pylint plugin
+cp "${TOXINIDIR}/pylint_plugins.py" "${ENVSITEPACKAGESDIR}"
+
+# build packages and bundles
+make -C "${TOXINIDIR}" \
+    wheel_bundle \
+    PYTHON="${ENVPYTHON}" \
+    IPA_EXTRA_WHEELS="$*"
+
+# chdir to prevent local .egg-info from messing up pip
+pushd "${ENVSITEPACKAGESDIR}"
+
+# Install packages with dist/bundle/ as extra source for wheels while ignoring
+# upstream Python Package Index.
+$ENVPYTHON -m pip install \
+    --no-index \
+    --disable-pip-version-check \
+    --constraint "${TOXINIDIR}/.wheelconstraints" \
+    --find-links "${DISTBUNDLE}" \
+    $@
+
+popd
diff --git a/Makefile.am b/Makefile.am
index 1989b19..ff3ce2a 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -57,6 +57,7 @@ EXTRA_DIST = .mailmap \
 clean-local:
 	rm -rf "$(RPMBUILD)"
 	rm -rf "$(top_builddir)/dist"
+	rm -rf "$(top_builddir)/.tox"
 	rm -rf "$(top_srcdir)/__pycache__"
 	rm -f "$(top_builddir)"/$(PACKAGE)-*.tar.gz
 
@@ -212,6 +213,7 @@ pylint: $(top_builddir)/ipapython/version.py ipasetup.py
 		-path './freeipa-*' -prune -o \
 		-path './dist' -prune -o \
 		-path './pypi' -prune -o \
+		-path './.tox' -prune -o \
 		-name '.*' -o \
 		-name '*.in' -o \
 		-name '*~' -o \
diff --git a/configure.ac b/configure.ac
index 8f8751a..68601de 100644
--- a/configure.ac
+++ b/configure.ac
@@ -276,6 +276,7 @@ AC_CONFIG_COMMANDS([po/POTFILES.in],
 			-path "./${PACKAGE}-*" -prune -o dnl dist directories
 			-path '*/build' -prune -o dnl Python builds
 			-path '*/dist' -prune -o dnl Python dists
+			-path './.tox' -prune -o dnl Python tox test
 			-path './conf*' -prune -o dnl generated by configure
 			-name '*.py' -print -o dnl
 			-name '*.c' -print -o dnl
diff --git a/ipatests/conftest.py b/ipatests/conftest.py
index 61e889d..ab17575 100644
--- a/ipatests/conftest.py
+++ b/ipatests/conftest.py
@@ -52,7 +52,9 @@
     'ipaserver/build',
     'ipatests/build',
     # install/share/wsgi.py
-    'install/share'
+    'install/share',
+    # integration plugin imports from ipaplatform
+    'ipatests/pytest_plugins',
 ]
 
 
@@ -100,7 +102,6 @@ def pytest_cmdline_main(config):
     )
     for klass in cli_plugins:
         api.add_plugin(klass)
-
     # XXX workaround until https://fedorahosted.org/freeipa/ticket/6408 has
     # been resolved.
     if ipaserver is not None:
diff --git a/tox.ini b/tox.ini
new file mode 100644
index 0000000..18331af
--- /dev/null
+++ b/tox.ini
@@ -0,0 +1,38 @@
+[tox]
+minversion=2.3.1
+envlist=py27,py35,pylint2,pylint3
+skip_missing_interpreters=true
+skipsdist=true
+
+[testenv]
+# always re-create virtual env. A special install helper is used to configure,
+# build and install packages.
+recreate=True
+install_command={toxinidir}/.tox-install.sh {envpython} {envsitepackagesdir} {packages}
+changedir={envdir}
+setenv=
+    HOME={envtmpdir}
+deps=
+    ipaclient
+    ipatests
+commands=
+    {envpython} -bb {envbindir}/ipa-run-tests --ipaclient-unittests
+
+[testenv:pylint2]
+basepython=python2.7
+deps=
+    ipaclient
+    ipapython[certmonger]
+    pylint
+commands=
+    {envpython} -m pylint \
+        --rcfile={toxinidir}/pylintrc \
+        --load-plugins pylint_plugins \
+        {envsitepackagesdir}/ipaclient \
+        {envsitepackagesdir}/ipalib \
+        {envsitepackagesdir}/ipapython
+
+[testenv:pylint3]
+basepython=python3
+deps={[testenv:pylint2]deps}
+commands={[testenv:pylint2]commands}
-- 
Manage your subscription for the Freeipa-devel mailing list:
https://www.redhat.com/mailman/listinfo/freeipa-devel
Contribute to FreeIPA: http://www.freeipa.org/page/Contribute/Code

Reply via email to